unit EditDlg;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ComCtrls, ExtCtrls, DBTables, Db, Grids, DBGrids, Dialogs;

type
  TEditRoutePagesDlg1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    NewRoutePageControl: TPageControl;
    Nodes: TTabSheet;
    Routes: TTabSheet;
    OKBtn: TButton;
    CancelBtn: TButton;
    TownsListBox: TListBox;
    TownsEdit: TEdit;
    EnterTownPanel: TPanel;
    AddTownSpeedButton: TSpeedButton;
    RemoveTownSpeedButton: TSpeedButton;
    ChangeTownSpeedButton: TSpeedButton;
    RouteNameEdit: TEdit;
    TownNameLabel: TLabel;
    RouteNameLabel: TLabel;
    NextButton: TButton;
    RoutesTable: TTable;
    CreateRouteQuery: TQuery;
    InsertRoutePanel: TPanel;
    ViewRoutesPanel: TPanel;
    RoutesDBGrid: TDBGrid;
    RoutesDataSource: TDataSource;
    BrowseButton: TButton;
    RouteOpenDialog: TOpenDialog;
    procedure AddTownSpeedButtonClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure RemoveTownSpeedButtonClick(Sender: TObject);
    procedure ChangeTownSpeedButtonClick(Sender: TObject);
    procedure NextButtonClick(Sender: TObject);
    procedure TownsEditKeyPress(Sender: TObject; var Key: Char);
    procedure OKBtnClick(Sender: TObject);
  private
   procedure ClearAll;
  public
    { Public declarations }
  end;

var
  NewRoutePagesDlg1: TNewRoutePagesDlg1;

implementation

{$R *.DFM}
procedure TNewRoutePagesDlg1.ClearAll;
begin
    TownsEdit.Clear;
    RouteNameEdit.Clear;
    TownsListBox.Items.Clear;
    NewRoutePageControl.SelectNextPage(true);
end;

procedure TNewRoutePagesDlg1.AddTownSpeedButtonClick(Sender: TObject);
begin
     if TownsListBox.ItemIndex = -1 then
        TownsListBox.Items.Add(TownsEdit.Text)
     else
        TownsListBox.Items.Insert(TownsListBox.ItemIndex+1,TownsEdit.Text);
end;

procedure TNewRoutePagesDlg1.CancelBtnClick(Sender: TObject);
begin
    Close;
end;

procedure TNewRoutePagesDlg1.RemoveTownSpeedButtonClick(Sender: TObject);
begin
    TownsListBox.Items.Delete(TownsListBox.ItemIndex);
end;

procedure TNewRoutePagesDlg1.ChangeTownSpeedButtonClick(Sender: TObject);
begin
     if TownsListBox.ItemIndex > -1 then
        TownsListBox.Items.Strings[TownsListBox.ItemIndex] := TownsEdit.Text;
end;

procedure TNewRoutePagesDlg1.NextButtonClick(Sender: TObject);
  function Q( const aString: String ): String;
  begin
    if ( aString = '' ) then
        Result := 'null'
    else
        Result := Chr(39) + aString + Chr(39);    // ''' = three single quote marks in succession
 end;
 function SpacesToLines(aString : String) : String;
 var i : integer;
 begin
     for i := 1 to length(aString) do
         if aString[i] = ' ' then
            aString[i] :='_';
     result := aString;
 end;


var i : smallint;

begin
     if Length(RouteNameEdit.Text) = 0 then begin
        MessageDlg('Please insert Route Name',mtWarning,[mbOk],0);
        exit;
     end;
  try
    CreateRouteQuery.Close;
    CreateRouteQuery.SQL.Clear;
    CreateRouteQuery.SQL.Add('CREATE TABLE '+RouteNameEdit.Text );
    CreateRouteQuery.SQL.Add('( VEHICLE VARCHAR(20),');
    for i := 0 to TownsListBox.Items.Count-2 do
        CreateRouteQuery.SQL.Add(SpacesToLines(TownsListBox.Items.Strings[i])+' TIME,');
    CreateRouteQuery.SQL.Add(SpacesToLines(TownsListBox.Items.Strings[i])+' TIME );');
    CreateRouteQuery.ExecSQL;

  except on EDBEngineError do
    if MessageDlg('Table Exists. Do you want to drop it?',mtConfirmation,[mbYes,mbNo],0) = mrYes then begin
       CreateRouteQuery.SQL.Clear;
       CreateRouteQuery.SQL.Add('DROP TABLE '+RouteNameEdit.Text );
       CreateRouteQuery.ExecSQL;
       CreateRouteQuery.Close;
       CreateRouteQuery.SQL.Clear;
       CreateRouteQuery.SQL.Add('DELETE FROM ROUTESTOWNS ');
       CreateRouteQuery.SQL.Add('WHERE ROUTE = '+Q(RouteNameEdit.Text));
       CreateRouteQuery.ExecSQL;
       exit;
    end;
  end;

    CreateRouteQuery.SQL.Clear;
    for i := 0 to TownsListBox.Items.Count-1 do begin
        CreateRouteQuery.SQL.Add('INSERT INTO ROUTESTOWNS ');
        CreateRouteQuery.SQL.Add('VALUES ( '+Q(RouteNameEdit.Text)+','+
           Q(SpacesToLines(TownsListBox.Items.Strings[i]))+','+IntToStr(i)+')');
        CreateRouteQuery.ExecSQL;
        CreateRouteQuery.SQL.Clear;
    end;
    RoutesTable.Active    := False;
    RoutesTable.TableName := RouteNameEdit.Text+'.db';
    RoutesTable.Active := True;

    NewRoutePageControl.SelectNextPage(true);


end;

procedure TNewRoutePagesDlg1.TownsEditKeyPress(Sender: TObject;
  var Key: Char);
begin
    if Key = Chr(13) then
      AddTownSpeedButtonClick(Sender);
end;

procedure TNewRoutePagesDlg1.OKBtnClick(Sender: TObject);
begin
        RoutesTable.Edit;
       RoutesTable.Post;
       ClearAll;
       Close;
end;

end.

