{*****************************************************************************
 *
 *  EditRoute.pas - Edit Route Dialog
 *
 *  Copyright (c) 1999 Diego Amicabile
 *
 *  Author:     Diego Amicabile
 *  E-mail:     diegoami@yahoo.it
 *  Homepage:   http://www.geocities.com/diegoami
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation;
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 *
 *----------------------------------------------------------------------------
 *
 *  Revision history:
 *
 *     DATE     REV                 DESCRIPTION
 *  ----------- --- ----------------------------------------------------------
 *
 *****************************************************************************}

unit EditRoute;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ComCtrls, ExtCtrls, Db, DBTables, DBCtrls, Grids, DBGrids, dialogs;

type
  TPagesDlg = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    PageControl1: TPageControl;
    Nodes: TTabSheet;
    OKBtn: TButton;
    CancelBtn: TButton;

    DBGrid: TDBGrid;
    TopPanel: TPanel;
    ComboBox: TComboBox;
    DropTableButton: TButton;
    procedure FormShow(Sender: TObject);
    procedure ComboBoxChange(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure DropTableButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    MustCommit : boolean;
  public
    { Public declarations }
  end;

var
  PagesDlg: TPagesDlg;

implementation

uses DataMod;

{$R *.DFM}


procedure TPagesDlg.FormShow(Sender: TObject);
begin
  with RoutesDataModule do begin
    RoutesQuery.Close;
    RoutesQuery.Open;
    RoutesQuery.First;
    ComboBox.Items.Clear;
    while not RoutesQuery.EOF do begin
      ComboBox.Items.Add(RoutesQuery.Fields[0].AsString);
      RoutesQuery.Next;
    end;
  end;
end;

procedure TPagesDlg.ComboBoxChange(Sender: TObject);
begin
  with RoutesDataModule do begin
     if (RoutesTable.Active and RoutesTable.Modified ) and
        (MessageDlg('Do you want to save changes?',mtConfirmation,[mbYes,mbNo],0) = mrYes) then begin
                         RoutesTable.Edit;
                         RoutesTable.Post;
     end;
    RoutesTable.Active := false;
    RoutesTable.TableName := Combobox.Items.Strings[ComboBox.ItemIndex];
    RoutesTable.Active := true;
    DropTableButton.Enabled := True;
  end;

end;

procedure TPagesDlg.OKBtnClick(Sender: TObject);
begin
    if RoutesDataModule.RoutesTable.Active then begin
       RoutesDataModule.RoutesTable.Edit;
       RoutesDataModule.RoutesTable.Post;
    end;
    Close;
end;

procedure TPagesDlg.CancelBtnClick(Sender: TObject);
begin
     Close;
end;

procedure TPagesDlg.DropTableButtonClick(Sender: TObject);
begin
     if MessageDlg('Are you sure you want to drop this table?',mtConfirmation,[mbYes,mbNo],0) = mrYes then begin
        RoutesDataModule.RoutesTable.Active := false;
        RoutesDataModule.DropTable(RoutesDataModule.RoutesTable.TableName);
        FormShow(Sender);
     end;
end;

procedure TPagesDlg.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   RoutesDataModule.RoutesTable.Active := false;
   RoutesDataModule.RoutesQuery.Active := false;
   ComboBox.Items.Clear;
   ComboBox.Text := '';
end;

end.

