{*****************************************************************************
 *
 *  NewDatabase.pas - New Database Dialogo
 *
 *  Copyright (c) 1999 Diego Amicabile
 *
 *  Author:     Diego Amicabile
 *  E-mail:     diegoami@yahoo.it
 *  Homepage:   http://www.geocities.com/diegoami
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation;
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 *
 *----------------------------------------------------------------------------
 *
 *  Revision history:
 *
 *     DATE     REV                 DESCRIPTION
 *  ----------- --- ----------------------------------------------------------
 *
 *****************************************************************************}

unit NewDatabase;

interface
uses OpenDatabaseUnit, StdCtrls, Controls, Classes, ExtCtrls,
  Windows, Messages, SysUtils, Graphics,  Forms, Dialogs, Mask, ToolEdit, FileCtrl;

type
  TNewDatabaseDlg = class(TOpenDatabaseDlg)
    procedure OKBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  NewDatabaseDlg: TNewDatabaseDlg;

implementation

uses DataMod;

{$R *.DFM}

procedure TNewDatabaseDlg.OKBtnClick(Sender: TObject);
begin
     if DirectoryExists(OpenDatabaseEdit.Text) then begin
         RoutesDataModule.Update(OpenDatabaseEdit.Text);
         RoutesDataModule.CreateDatabase;
         Close;
    end else
        if (MessageDlg('This directory does not exist. Do you want to create it?',mtInformation,[mbYes, mbNo],0) = mrYes) then
           if CreateDir(OpenDatabaseEdit.Text) then
              OkBtnClick(Sender)
           else
              MessageDlg('Could not create directory',mtError,[mbOk],0);

end;

procedure TNewDatabaseDlg.FormCreate(Sender: TObject);
begin
  inherited;
  OpenDataBaseEdit.DialogOptions := [sdAllowCreate, sdPerformCreate];
end;

end.
