unit NewRoute;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ComCtrls, ExtCtrls, DBTables, Db, Grids, DBGrids, Dialogs;

type
  TEditRoutePagesDlg = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    NewRoutePageControl: TPageControl;
    Nodes: TTabSheet;
    Routes: TTabSheet;
    OKBtn: TButton;
    CancelBtn: TButton;
    TownsListBox: TListBox;
    TownsEdit: TEdit;
    EnterTownPanel: TPanel;
    AddTownSpeedButton: TSpeedButton;
    RemoveTownSpeedButton: TSpeedButton;
    ChangeTownSpeedButton: TSpeedButton;
    RouteNameEdit: TEdit;
    TownNameLabel: TLabel;
    RouteNameLabel: TLabel;
    NextButton: TButton;
    InsertRoutePanel: TPanel;
    ViewRoutesPanel: TPanel;
    RoutesDBGrid: TDBGrid;
    BothWayRadioButton: TRadioButton;
    OtherWayEdit: TEdit;
    OtherWayLabel: TLabel;
    OtherWayButton: TButton;
    procedure AddTownSpeedButtonClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure RemoveTownSpeedButtonClick(Sender: TObject);
    procedure ChangeTownSpeedButtonClick(Sender: TObject);
    procedure NextButtonClick(Sender: TObject);
    procedure TownsEditKeyPress(Sender: TObject; var Key: Char);
    procedure OKBtnClick(Sender: TObject);
    procedure BothWayRadioButtonClick(Sender: TObject);
    procedure OtherWayButtonClick(Sender: TObject);
  private
   procedure ClearAll;
  public
    { Public declarations }
  end;

var
  NewRoutePagesDlg: TEditRoutePagesDlg;

implementation

uses DataMod;

{$R *.DFM}
procedure TEditRoutePagesDlg.ClearAll;
begin
    TownsEdit.Clear;
    RouteNameEdit.Clear;
    TownsListBox.Items.Clear;
    NewRoutePageControl.ActivePage := Nodes;
end;

procedure TEditRoutePagesDlg.AddTownSpeedButtonClick(Sender: TObject);
begin
     if TownsListBox.ItemIndex = -1 then
        TownsListBox.Items.Add(TownsEdit.Text)
     else
        TownsListBox.Items.Insert(TownsListBox.ItemIndex+1,TownsEdit.Text);
end;

procedure TEditRoutePagesDlg.CancelBtnClick(Sender: TObject);
begin
    Close;
end;

procedure TEditRoutePagesDlg.RemoveTownSpeedButtonClick(Sender: TObject);
begin
    TownsListBox.Items.Delete(TownsListBox.ItemIndex);
end;

procedure TEditRoutePagesDlg.ChangeTownSpeedButtonClick(Sender: TObject);
begin
     if TownsListBox.ItemIndex > -1 then
        TownsListBox.Items.Strings[TownsListBox.ItemIndex] := TownsEdit.Text;
end;

procedure TEditRoutePagesDlg.NextButtonClick(Sender: TObject);

  function Reverse(ts : TStrings) : TStrings;
  var ls : TStringList;
      i  : smallint;
      aString : String;
  begin
     ls := TStringList.Create;
     for i := ts.Count-1 downto 0 do begin
           aString := ts.Strings[i];
           ls.add(aString);
     end;
     result := ls;
  end;



begin
     if Length(RouteNameEdit.Text) = 0 then begin
        MessageDlg('Please insert Route Name',mtWarning,[mbOk],0);
        exit;
     end;
     if (BothWayRadioButton.Checked) and (Length(OtherWayEdit.Text) = 0) then begin
            MessageDlg('Please insert Alternate Route Name',mtWarning,[mbOk],0);
            exit;
     end;
     RoutesDataModule.CreateTable(RouteNameEdit.Text,TownsListBox.Items);

     if BothWayRadioButton.Checked then
         RoutesDataModule.CreateTable(OtherWayEdit.Text,Reverse(TownsListBox.Items));

    RoutesDataModule.RoutesTable.Active    := False;
    RoutesDataModule.RoutesTable.TableName := RouteNameEdit.Text+'.db';
    RoutesDataModule.RoutesTable.Active    := True;

    NewRoutePageControl.SelectNextPage(true);

end;

procedure TEditRoutePagesDlg.TownsEditKeyPress(Sender: TObject;
  var Key: Char);
begin
    if Key = Chr(13) then
      AddTownSpeedButtonClick(Sender);
end;

procedure TEditRoutePagesDlg.OKBtnClick(Sender: TObject);
begin
        RoutesDataModule.RoutesTable.Edit;
       RoutesDataModule.RoutesTable.Post;
       ClearAll;
       Close;
end;

procedure TEditRoutePagesDlg.BothWayRadioButtonClick(Sender: TObject);
begin
       OtherWayEdit.Enabled   := BothWayRadioButton.Checked;
       OtherWayButton.Enabled := BothWayRadioButton.Checked;
end;

procedure TEditRoutePagesDlg.OtherWayButtonClick(Sender: TObject);
begin
       OtherWayButton.Enabled := False;
        
       RoutesDataModule.RoutesTable.Active    := False;
      RoutesDataModule.RoutesTable.TableName := OtherWayEdit.Text+'.db';
      RoutesDataModule.RoutesTable.Active    := True;

end;

end.

