{*****************************************************************************
 *
 *  OpenDatabaseUnit.pas - Open Database Dialog
 *
 *  Copyright (c) 1999 Diego Amicabile
 *
 *  Author:     Diego Amicabile
 *  E-mail:     diegoami@yahoo.it
 *  Homepage:   http://www.geocities.com/diegoami
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation;
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 *
 *----------------------------------------------------------------------------
 *
 *  Revision history:
 *
 *     DATE     REV                 DESCRIPTION
 *  ----------- --- ----------------------------------------------------------
 *
 *****************************************************************************}

unit OpenDatabaseUnit;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls,  dialogs, Mask, ToolEdit, FileCtrl;

type
  TOpenDatabaseDlg = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    Bevel: TBevel;
    DirectoryLabel: TLabel;
    OpenDataBaseEdit: TDirectoryEdit;
    procedure OKBtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  OpenDatabaseDlg: TOpenDatabaseDlg;

implementation

uses DataMod;

{$R *.DFM}

procedure TOpenDatabaseDlg.OKBtnClick(Sender: TObject);
begin
    if DirectoryExists(OpenDatabaseEdit.Text) then begin
         RoutesDataModule.Update(OpenDatabaseEdit.Text);
         Close;
    end else
        MessageDlg('This directory does not exist',mtWarning,[mbOk],0);
end;

procedure TOpenDatabaseDlg.CancelBtnClick(Sender: TObject);
begin
    Close;
end;

procedure TOpenDatabaseDlg.FormCreate(Sender: TObject);
begin
    OpenDatabaseEdit.Text := RoutesDataModule.DatabaseDir;
end;

end.
