{*****************************************************************************
 *
 *  TT.pas - Main Form
 *
 *  Copyright (c) 1999 Diego Amicabile
 *
 *  Author:     Diego Amicabile
 *  E-mail:     diegoami@yahoo.it
 *  Homepage:   http://www.geocities.com/diegoami
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation;
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 *
 *----------------------------------------------------------------------------
 *
 *  Revision history:
 *
 *     DATE     REV                 DESCRIPTION
 *  ----------- --- ----------------------------------------------------------
 *
 *****************************************************************************}

unit TT;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, shellapi, Buttons, ExtCtrls,inifiles;

type
  TMainForm = class(TForm)
    MainMenu: TMainMenu;
    FileMenuItem: TMenuItem;
    NewRouteMenuItem: TMenuItem;
    CalculateMenuItem: TMenuItem;
    FindRouteMenuItem: TMenuItem;
    EditRouteMenuItem: TMenuItem;
    N1: TMenuItem;
    ExitMenuItem: TMenuItem;
    HelpMenuItem: TMenuItem;
    N2: TMenuItem;
    OpenDatabaseMenuItem: TMenuItem;
    NewDatabaseMenuItem: TMenuItem;
    Panel: TPanel;
    NewDatabaseSpeedButton: TSpeedButton;
    OpenDatabaseSpeedButton: TSpeedButton;
    NewRouteSpeedButton: TSpeedButton;
    EditRouteSpeedButton: TSpeedButton;
    SearchSpeedButton: TSpeedButton;
    ExitSpeedButton: TSpeedButton;
    procedure NewRouteMenuItemClick(Sender: TObject);
    procedure FindRouteMenuItemClick(Sender: TObject);
    procedure EditRouteMenuItemClick(Sender: TObject);
    procedure ExitMenuItemClick(Sender: TObject);
    procedure HelpMenuItemClick(Sender: TObject);
    procedure NewDatabaseMenuItemClick(Sender: TObject);
    procedure OpenDatabaseMenuItemClick(Sender: TObject);
  
  private
    IlFileIni   : TIniFile;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses NewRoute, Search, EditRoute, DataMod, NewDatabase, OpenDatabaseUnit,
  WizardUnit;

{$R *.DFM}

procedure TMainForm.NewRouteMenuItemClick(Sender: TObject);
begin
  NewRouteWizard.Show;
end;

procedure TMainForm.FindRouteMenuItemClick(Sender: TObject);
begin
  SearchForm.Show;
end;

procedure TMainForm.EditRouteMenuItemClick(Sender: TObject);
begin
  PagesDlg.Show;
end;

procedure TMainForm.ExitMenuItemClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.HelpMenuItemClick(Sender: TObject);
var HelpFile : String;
begin
  HelpFile := GetcurrentDir+'\help\help.html';
  Shellexecute(0,nil,Pchar(HelpFile),nil,nil,SW_NORMAL);
end;

procedure TMainForm.NewDatabaseMenuItemClick(Sender: TObject);
begin
  NewDatabaseDlg.Show;
end;

procedure TMainForm.OpenDatabaseMenuItemClick(Sender: TObject);
begin
  OpenDatabaseDlg.Show;
end;

end.
